<script>
import { mapState } from 'vuex';
import { SocketState } from 'colibri-sockets';
import WebsocketsDropdown from '~/components/ui/websockets-dropdown.vue';

export default {
  name: `app-footer`,
  components: { WebsocketsDropdown },
  data() {
    return {
      showWebsocketsDropdown: false,
    }
  },
  computed: {
    ...mapState({
      websockets: (state) => state.websockets.websockets,
      selectedWebsocket: (state) => state.websockets.selectedWebsocket,
    }),
    year() {
      return new Date().getFullYear();
    },
    openWS() {
      if (this.websockets === null) return[];
      const ws = this.websockets.filter((ws) => ws.state === SocketState.CONNECTED);
      return ws.map((w) => ({ value: w.name, text: w.filename }));
    },
    hasOpenWS() {
      return this.openWS.length > 0;
    },
  },
  methods: {
    setSelectedWebsocket(value) {
      this.$store.commit("websockets/setSelectedWebsocket", value);
    },
    closeWebsocketsDropdown() {
      this.showWebsocketsDropdown = false;
    },
  },
}
</script>

<template>
  <v-app-bar app dense bottom>
    <v-app-bar-title class="text-subtitle-1">
      Les Fées Spéciales, M. Pêcheux © {{ year }}. <a href="https://gitlab.com/lfs.coop/colibri">{{ $t(`footer.source-code`) }}</a>
    </v-app-bar-title>
    <v-spacer />
    <v-row class="flex-grow-0" no-gutters>
      <cbr-dropdown
        v-if="hasOpenWS"
        :items="openWS"
        :value="selectedWebsocket"
        @input="setSelectedWebsocket"
        outlined
        dense
        hide-details
        class="mr-4"
      />
      <websockets-dropdown v-show="websockets && websockets.length > 0" />
    </v-row>
  </v-app-bar>
</template>
